#include <iostream>
#include <fstream>
#include <string.h>
using namespace std;

const int MAXS = 100;
const int MAXI = 200;
const int MAXE = 50;

struct Data {
  int giorno;
  int mese;
  int anno;
};

struct Esame {
  char insegnamento[MAXS];
  int voto;
  int cfu;
  Data data;
};

struct Studente {
  char nome[MAXS];
  char cognome[MAXS];
  int matricola;
  Esame esa[MAXE];
  int numEs;
};

struct Iscritti {
  Studente stud[MAXI];
  int numIscr;
};


int carica(Iscritti* pi, const char nomef[]);
int ammontareCFU(const Iscritti* pi, Data d1, Data d2); 
float media(const Iscritti* pi, int matr);
void stampaMigliori(const Iscritti* pi, const char ins[]);
void stampaInsSup(const Iscritti* pi);


Data leggiData(){
  Data d;
  cout << "Inserisci giorno:";
  cin >> d.giorno;
  cout << "Inserisci mese:";
  cin >> d.mese;
  cout << "Inserisci anno:";
  cin >> d.anno;
  return d;
}

void visualizzaTutto(const Iscritti* pi){
  for(int i=0; i<pi->numIscr; i++){
    cout << endl;
    cout << pi->stud[i].nome << '\t' << pi->stud[i].cognome << '\t' << pi->stud[i].matricola << endl;
    for(int j=0; j<pi->stud[i].numEs; j++){
      cout << pi->stud[i].esa[j].insegnamento << '\t' << pi->stud[i].esa[j].cfu << '\t' << pi->stud[i].esa[j].voto;
      cout << '\t' << pi->stud[i].esa[j].data.giorno << '/' << pi->stud[i].esa[j].data.mese << '/' << pi->stud[i].esa[j].data.anno << endl;
    }  
  }  
}

void menu(){
  cout << "--------------------" << endl;
  cout << "1) carica" << endl;
  cout << "2) ammontare cfu" << endl;
  cout << "3) media" << endl;
  cout << "4) stampa migliori" << endl;
  cout << "5) stampa ins sup" << endl;
  cout << "6) visualizza tutto" << endl;
  cout << "7) esci" << endl;
}

int main(){
  Iscritti iscr;
  iscr.numIscr = 0;
  
  char s;
  int i;
  float m;
  int mat;
  Data d1, d2;
  char ins[MAXS];

  while(true){
    menu();
    cin >> s;
    switch(s){
      case '1':
        i = carica(&iscr, "input.txt");
        cout << "Ho caricato i dati di " << i << " studenti" << endl;
        break;
      case '2':
        cout << "Inserisci prima data" << endl;
        d1 = leggiData(); 
        cout << "Inserisci seconda data" << endl;
        d2 = leggiData(); 
        i = ammontareCFU(&iscr, d1, d2);
        cout << "Totale CFU: " << i << endl;
        break;
      case '3':
        cout << "Inserisci numero di matricola: ";
        cin >> mat;
        m = media(&iscr, mat);
        cout << "Media: " << m << endl;
      break;
      case '4':
        cout << "Quale insegnamento: ";
        cin >> ins;
        stampaMigliori(&iscr, ins);      
        break;
      case '5':
        stampaInsSup(&iscr);
        break;
      case '6':
        visualizzaTutto(&iscr);
        break;
      case '7':
        return 0;
    }
  }
}
