#include <iostream>
#include <fstream>
#include <string.h>
using namespace std;

const int MAXS = 100;
const int MAXI = 200;
const int MAXE = 50;

struct Data {
  int giorno;
  int mese;
  int anno;
};

struct Esame {
  char insegnamento[MAXS];
  int voto;
  int cfu;
  Data data;
};

struct Studente {
  char nome[MAXS];
  char cognome[MAXS];
  int matricola;
  Esame esa[MAXE];
  int numEs;
};

struct Iscritti {
  Studente stud[MAXI];
  int numIscr;
};


int carica(Iscritti* pi, const char nomef[]) {
  fstream f;
  f.open(nomef, ios::in);
  if(!f) 
    return 0;
  Studente s;
  int num;
  while(f>>s.nome>>s.cognome>>s.matricola>>num) {
    if(pi->numIscr == MAXI) break;
    for(int i=0; i<num && i<MAXE; i++) 
      f>>s.esa[i].insegnamento>> s.esa[i].cfu >>s.esa[i].voto>>s.esa[i].data.giorno>>s.esa[i].data.mese>>s.esa[i].data.anno; 
    s.numEs = num;
    pi->stud[pi->numIscr++] = s;
  }
  
  return pi->numIscr;
}

int confronta(Data i, Data j) {
  if(i.anno != j.anno) return i.anno - j.anno;
  if(i.mese != j.mese) return i.mese - j.mese;
  return i.giorno - j.giorno;
}

bool compresa(Data x, Data a, Data b) {
  return confronta(x, a) >= 0 && confronta(x, b) <= 0;
}

int ammontareCFU(const Iscritti* pi, Data d1, Data d2) { 
  int tot = 0;
  for(int i=0; i<pi->numIscr; i++)
    for(int j=0; j<pi->stud[i].numEs; j++)
      if(compresa(pi->stud[i].esa[j].data, d1, d2))
        tot += pi->stud[i].esa[j].cfu;
  return tot;
}

float media(const Iscritti* pi, int matr) {
  int totcfu = 0;
  float totvoto = 0.0f;
  for(int i=0; i<pi->numIscr; i++)
    if(pi->stud[i].matricola == matr) {
      for(int j=0; j<pi->stud[i].numEs; j++) {
        int c = pi->stud[i].esa[j].cfu;
        int v = pi->stud[i].esa[j].voto;
        totcfu += c;
        totvoto += c*v;
      }
      return totvoto/totcfu;
    }
  return 0.0f;
}

void stampaMigliori(const Iscritti* pi, const char ins[]) {
  int votomax = 0;
  for(int i=0; i<pi->numIscr; i++)
    for(int j=0; j<pi->stud[i].numEs; j++) {
      if(strcmp(pi->stud[i].esa[j].insegnamento, ins) == 0 && 
         pi->stud[i].esa[j].voto > votomax)
        votomax = pi->stud[i].esa[j].voto;
    }
  for(int i=0; i<pi->numIscr; i++)
    for(int j=0; j<pi->stud[i].numEs; j++) {
      if(strcmp(pi->stud[i].esa[j].insegnamento, ins) == 0 && pi->stud[i].esa[j].voto == votomax)
        cout << pi->stud[i].cognome << '\t' << pi->stud[i].nome << '\t' << votomax << endl;
    }
}

struct InsSup {
  char ins[MAXS];
  int sup;
};

int aggiungi(InsSup v[], int q, const char in[]) {
  for(int i=0; i<q; i++)
    if(strcmp(v[i].ins, in) == 0) {
      v[i].sup++;
      return q;
  }
  strcpy(v[q].ins, in);
  v[q].sup = 1;
  return ++q;
}

void ordina(InsSup v[], int n) {
  for(int i=0; i<n-1; i++) {
    int index = i;
    for(int j=i+1; j<n; j++)
      if(v[j].sup > v[index].sup)
        index = j;
    InsSup tmp = v[i];
    v[i] = v[index];
    v[index] = tmp;
  }
}

void stampaInsSup(const Iscritti* pi) {
  InsSup aux[MAXE];
  int q = 0;
  for(int i=0; i<pi->numIscr; i++)
    for(int j=0; j<pi->stud[i].numEs; j++)
      q = aggiungi(aux, q, pi->stud[i].esa[j].insegnamento);
  ordina(aux, q);
  for(int i=0; i<q; i++) 
    cout << aux[i].ins << '\t' << aux[i].sup << endl; 
}
